### Home Classes Methods

### In Files

- lib/sass/tree/node.rb

### Parent

Object

### Methods

- ::new
- #<<
- #==
- #balance
- #bubbles?
- #children=
- #deep_copy
- #each
- #filename
- #inspect
- #invisible?
- #options=
- #style
- #to_s
- #to_sass
- #to_scss

### Included Modules

- Enumerable

### Class/Module Index

Quicksearch

- Sass
- Sass::CSS
- Sass::CacheStores
- Sass::CacheStores::Base
- Sass::CacheStores::Chain
- Sass::CacheStores::Filesystem
- Sass::CacheStores::Memory
- Sass::CacheStores::Null
- Sass::Callbacks
- Sass::Callbacks::InstanceMethods
- Sass::Engine
- Sass::Engine::Line
- Sass::Environment
- Sass::Exec
- Sass::Exec::Generic
- Sass::Exec::Sass
- Sass::Exec::SassConvert
- Sass::Exec::Scss
- Sass::Importers
- Sass::Importers::Base
- Sass::Importers::Filesystem
- Sass::Logger
- Sass::Logger::Base
- Sass::Logger::LogLevel
- Sass::Logger::LogLevel::ClassMethods
- Sass::Media
- Sass::Media::Query
- Sass::Media::QueryList
- Sass::Plugin
- Sass::Plugin::Compiler
- Sass::Plugin::Configuration
- Sass::Plugin::MerbBootLoader
- Sass::Plugin::Rack
- Sass::Plugin::StalenessChecker
- Sass::Repl
- Sass::SCSS
- Sass::SCSS::CssParser
- Sass::SCSS::Parser
- Sass::SCSS::RX
- Sass::SCSS::ScriptLexer
- Sass::SCSS::ScriptParser
- Sass::SCSS::StaticParser
- Sass::Script
- Sass::Script::ArgList
- Sass::Script::Bool
- Sass::Script::Color
- Sass::Script::CssLexer
- Sass::Script::CssParser
- Sass::Script::Funcall
- Sass::Script::Functions
- Sass::Script::Functions::EvaluationContext
- Sass::Script::Interpolation
- Sass::Script::Lexer
- Sass::Script::List
- Sass::Script::Literal
- Sass::Script::Node
- Sass::Script::Null
- Sass::Script::Number
- Sass::Script::Operation
- Sass::Script::Parser
- Sass::Script::String
- Sass::Script::StringInterpolation
- Sass::Script::UnaryOperation
- Sass::Script::Variable
- Sass::Selector
- Sass::Selector::AbstractSequence
- Sass::Selector::Attribute
- Sass::Selector::Class
- Sass::Selector::CommaSequence
- Sass::Selector::Element
- Sass::Selector::Id
- Sass::Selector::Interpolation
- Sass::Selector::Parent
- Sass::Selector::Placeholder
- Sass::Selector::Pseudo
- Sass::Selector::SelectorPseudoClass
- Sass::Selector::Sequence
- Sass::Selector::Simple
- Sass::Selector::SimpleSequence
- Sass::Selector::Universal
- Sass::Shared
- Sass::Supports
- Sass::Supports::Condition
- Sass::Supports::Declaration
- Sass::Supports::Interpolation
- Sass::Supports::Negation
- Sass::Supports::Operator
- Sass::SyntaxError
- Sass::Tree
- Sass::Tree::CharsetNode
- Sass::Tree::CommentNode
- Sass::Tree::ContentNode
- Sass::Tree::CssImportNode
- Sass::Tree::DebugNode
- Sass::Tree::DirectiveNode
- Sass::Tree::EachNode
- Sass::Tree::ExtendNode
- Sass::Tree::ForNode
- Sass::Tree::FunctionNode
- Sass::Tree::IfNode
- Sass::Tree::ImportNode
- Sass::Tree::MediaNode
- Sass::Tree::MixinDefNode
- Sass::Tree::MixinNode
- Sass::Tree::Node
- Sass::Tree::PropNode
- Sass::Tree::ReturnNode
- Sass::Tree::RootNode
- Sass::Tree::RuleNode
- Sass::Tree::SupportsNode
- Sass::Tree::TraceNode
- Sass::Tree::VariableNode
- Sass::Tree::Visitors
- Sass::Tree::Visitors::Base
- Sass::Tree::Visitors::CheckNesting
- Sass::Tree::Visitors::Convert
- Sass::Tree::Visitors::Cssize
- Sass::Tree::Visitors::DeepCopy
- Sass::Tree::Visitors::Extend
- Sass::Tree::Visitors::Perform
- Sass::Tree::Visitors::SetOptions
- Sass::Tree::Visitors::ToCss
- Sass::Tree::WarnNode
- Sass::Tree::WhileNode
- Sass::UnitConversionError
- Sass::Util
- Sass::Util::MultibyteStringScanner
- Sass::Util::StaticConditionalContext
- Sass::Util::SubsetMap
- Sass::Util::Test
- Sass::Version
- ActionController
- ActionController::Base
- Object

No matching classes.

# Sass::Tree::Node

The abstract superclass of all parse-tree nodes.

### Attributes

children[RW]

The child nodes of this node.

@return [Array<Tree::Node>]

filename[W]

The name of the document on which this node appeared.

@return [String]

has_children[RW]

Whether or not this node has child nodes. This may be true even when {#children} is empty, in which case this node has an empty block (e.g. `{}`).

@return [Boolean]

line[RW]

The line of the document on which this node appeared.

@return [Fixnum]

options[R]

The options hash for the node. See {file:SASS_REFERENCE.md#sass_options the Sass options documentation}.

@return [{Symbol => Object}]

### Public Class Methods

new() click to toggle source

    # File lib/sass/tree/node.rb, line 60
    def initialize
      @children = []
    end

### Public Instance Methods

<<(child) click to toggle source

Appends a child to the node.

@param child [Tree::Node, Array<Tree::Node>] The child node or nodes @raise [Sass::SyntaxError] if `child` is invalid

    # File lib/sass/tree/node.rb, line 89
    def <<(child)
      return if child.nil?
      if child.is_a?(Array)
        child.each {|c| self << c}
      else
        self.has_children = true
        @children << child
      end
    end

==(other) click to toggle source

Compares this node and another object (only other {Tree::Node}s will be equal). This does a structural comparison; if the contents of the nodes and all the child nodes are equivalent, then the nodes are as well.

Only static nodes need to override this.

@param other [Object] The object to compare with @return [Boolean] Whether or not this node and the other object

    are the same

@see Sass::Tree

    # File lib/sass/tree/node.rb, line 110
    def ==(other)
      self.class == other.class && other.children == children
    end

bubbles?() click to toggle source

Whether or not this node bubbles up through RuleNodes.

@return [Boolean]

    # File lib/sass/tree/node.rb, line 181
    def bubbles?
      false
    end

children=(children) click to toggle source

@private

    # File lib/sass/tree/node.rb, line 73
    def children=(children)
      self.has_children ||= !children.empty?
      @children = children
    end

deep_copy() click to toggle source

Return a deep clone of this node. The child nodes are cloned, but options are not.

@return [Node]

    # File lib/sass/tree/node.rb, line 174
    def deep_copy
      Sass::Tree::Visitors::DeepCopy.visit(self)
    end

each() click to toggle source

Iterates through each node in the tree rooted at this node in a pre-order walk.

@yield node @yieldparam node [Node] a node in the tree

    # File lib/sass/tree/node.rb, line 149
    def each
      yield self
      children.each {|c| c.each {|n| yield n}}
    end

filename() click to toggle source

The name of the document on which this node appeared.

@return [String]

    # File lib/sass/tree/node.rb, line 81
    def filename
      @filename || (@options && @options[:filename])
    end

inspect() click to toggle source

Returns a representation of the node for debugging purposes.

@return [String]

    # File lib/sass/tree/node.rb, line 139
    def inspect
      return self.class.to_s unless has_children
      "(#{self.class} #{children.map {|c| c.inspect}.join(' ')})"
    end

invisible?() click to toggle source

True if {#to_s} will return `nil`; that is, if the node shouldn't be rendered. Should only be called in a static tree.

@return [Boolean]

    # File lib/sass/tree/node.rb, line 119
    def invisible?; false; end

options=(options) click to toggle source

Sets the options hash for the node and all its children.

@param options [{Symbol => Object}] The options @see options

    # File lib/sass/tree/node.rb, line 68
    def options=(options)
      Sass::Tree::Visitors::SetOptions.visit(self, options)
    end

style() click to toggle source

The output style. See {file:SASS_REFERENCE.md#sass_options the Sass options documentation}.

@return [Symbol]

    # File lib/sass/tree/node.rb, line 124
    def style
      @options[:style]
    end

to_s() click to toggle source

Computes the CSS corresponding to this static CSS tree.

@return [String, nil] The resulting CSS @see Sass::Tree

    # File lib/sass/tree/node.rb, line 132
    def to_s
      Sass::Tree::Visitors::ToCss.visit(self)
    end

to_sass(options = {}) click to toggle source

Converts a node to Sass code that will generate it.

@param options [{Symbol => Object}] An options hash (see {Sass::CSS#initialize}) @return [String] The Sass code corresponding to the node

    # File lib/sass/tree/node.rb, line 158
    def to_sass(options = {})
      Sass::Tree::Visitors::Convert.visit(self, options, :sass)
    end

to_scss(options = {}) click to toggle source

Converts a node to SCSS code that will generate it.

@param options [{Symbol => Object}] An options hash (see {Sass::CSS#initialize}) @return [String] The Sass code corresponding to the node

    # File lib/sass/tree/node.rb, line 166
    def to_scss(options = {})
      Sass::Tree::Visitors::Convert.visit(self, options, :scss)
    end

### Protected Instance Methods

balance(*args) click to toggle source

@see Sass::Shared.balance @raise [Sass::SyntaxError] if the brackets aren't balanced

    # File lib/sass/tree/node.rb, line 189
    def balance(*args)
      res = Sass::Shared.balance(*args)
      return res if res
      raise Sass::SyntaxError.new("Unbalanced brackets.", :line => line)
    end

[Validate]

Generated with the Darkfish Rdoc Generator 2.